<template>
    <v-app dark>
        <!-- APP BAR -->
        <app-bar />

        <!-- SNACK BAR -->
        <snack-bar />

        <!-- DIALOG BAR -->
        <dialog-bar />

        <!-- MENU DRAWER -->
        <menu-drawer />

        <!-- FILTER DRAWER -->
        <filter-drawer />

        <!-- CART DRAWER -->
        <cart-drawer />

        <!-- PAGES -->
        <v-main>
            <v-container fluid>
                <div v-if="$fetchState.pending" id="loader-wrapper">
                    <v-progress-circular indeterminate color="black" />
                </div>
                <nuxt v-else />
            </v-container>
        </v-main>

        <!-- FOOTER -->
        <app-footer />
    </v-app>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import MenuDrawer from '~/components/drawer/menuDrawer.vue'
import FilterDrawer from '~/components/drawer/filterDrawer.vue'
import CartDrawer from '~/components/drawer/cartDrawer.vue'

Vue.component('menu-drawer', MenuDrawer)
Vue.component('filter-drawer', FilterDrawer)
Vue.component('cart-drawer', CartDrawer)

@Component({
    async fetch() {
        if (this.$cookies.get('t')) {
            const [userProfile, userAddresses, userCardSetup, userWishlist] =
                await Promise.all([
                    this.$api.user.profile(),
                    this.$api.user.listAddress(),
                    this.$api.user.cardSetup(),
                    this.$api.wishlist.getWishlist(),
                ])

            if (userProfile.data) {
                this.$store.commit('user/setUser', userProfile.data)

                if (userAddresses.data) {
                    this.$store.dispatch(
                        'user/handleAddressApi',
                        userAddresses.data
                    )
                }

                if (userWishlist.data) {
                    this.$store.dispatch(
                        'wishlist/updateWishlist',
                        userWishlist.data
                    )
                }

                // get shop cart
                const userShopCart = await this.$api.cart.getShopCart()

                if (userShopCart.data.items.length > 0) {
                    this.$store.dispatch(
                        'cart/updateCartShop',
                        userShopCart.data
                    )
                }

                // get user subscription
                const userSubscription = await this.$api.user.subscriptions()

                if (userSubscription.data) {
                    if (Object.keys(userSubscription.data).length > 0) {
                        this.$store.dispatch(
                            'subscription/setPlan',
                            userSubscription.data
                        )

                        // get user cart
                        const userCart = await this.$api.cart.getCart()

                        if (userCart.data) {
                            if (Object.keys(userCart.data).length > 0) {
                                this.$store.dispatch(
                                    'cart/updateCart',
                                    userCart.data
                                )

                                // get user surcharges
                                const userSurcharges =
                                    await this.$api.cart.getSurcharges()

                                if (userSurcharges.data) {
                                    if (
                                        Object.keys(userSurcharges.data)
                                            .length > 0
                                    ) {
                                        this.$store.dispatch(
                                            'cart/updateSurcharges',
                                            userSurcharges.data
                                        )
                                    }
                                }
                            }
                        }
                    }
                }

                this.$store.commit(
                    'cart/setStripeClientSecret',
                    userCardSetup.data
                )
            }
        }
    },

    // fetchOnServer: false,
})
export default class Default extends Vue {
    mounted() {}
}
</script>
